//
// nono
// Copyright (C) 2021 nono project
// Licensed under nono-license.txt
//

#include "cuimessage.h"

std::array<CUIMessage::Func, UIMessage::ID_MAX> CUIMessage::func_table;

// UIMessage を func に接続する
/*static*/ void
CUIMessage::Connect(UIMessage::ID id, CUIMessage::Func func)
{
	func_table[id] = func;
}

// UIMessage を処理する
/*static*/ void
CUIMessage::Process(UIMessage::Queue& queue)
{
	UIMessage m;

	while (queue.Dequeue(&m)) {
		UIMessage::ID id = m.GetID();
		if (id < 0 || id >= UIMessage::ID_MAX) {
			PANIC("Invalid UIMessage %d", id);
		}
		auto func = func_table[id];
		if (func) {
			func(m);
		}
	}
}
