//
// nono
// Copyright (C) 2021 nono project
// Licensed under nono-license.txt
//

#pragma once

#include "uimessage.h"
#include <array>
#include <functional>

class CUIMessage
{
	using Func = std::function<void(const UIMessage&)>;
 public:
	// UIMessage を func に接続する
	static void Connect(UIMessage::ID id, Func func);

	// UIMessage を処理する
	static void Process(UIMessage::Queue& queue);

 private:
	static std::array<Func, UIMessage::ID_MAX> func_table;
};
