//
// nono
// Copyright (C) 2020 nono project
// Licensed under nono-license.txt
//

#include "header.h"
#include "console.h"

//
// 標準入出力コンソール
//

// コンストラクタ
ConsoleStdio::ConsoleStdio()
{
#if defined(HAVE_HISTEDIT_H)
	// editline があれば使う
	use_editline = true;
#endif
}

// デストラクタ
ConsoleStdio::~ConsoleStdio()
{
}

// 初期化
bool
ConsoleStdio::Init()
{
	// stdin,out 相当なので開きっぱなしにする
	if (inp.fd == -1) {
		inp.fd = STDIN_FILENO;
		out.fd = STDOUT_FILENO;
		FDOpen();
	}
	return true;
}

// 受け付ける
bool
ConsoleStdio::Accept()
{
	// 何もしなくていい
	return true;
}

void
ConsoleStdio::Close()
{
	// stdin,out 相当なので開きっぱなしにする
}
