//
// nono
// Copyright (C) 2021 nono project
// Licensed under nono-license.txt
//

// AF_PACKET を用いたドライバ
// Linux 2.2 以降専用

#pragma once

#include "netdriver.h"
#include <sys/socket.h>
#include <netpacket/packet.h>
#include <net/ethernet.h>

class NetDriverAFPacket : public NetDriver
{
	using inherited = NetDriver;
 public:
	// コンストラクタ
	NetDriverAFPacket(EthernetDevice *parent_, int loglevel_,
		const std::string& devpath_);
	// デストラクタ
	~NetDriverAFPacket() override;

	bool InitDriver() override;
	bool SendPacket(const std::vector<uint8>& data) override;

 protected:
	ssize_t RecvPacket() override;
	void MonitorUpdateMD(TextScreen&) override;

 private:
	void Close();

	int SelectInterface();

	sockaddr_ll sll {};
};
