//
// nono
// Copyright (C) 2020 nono project
// Licensed under nono-license.txt
//

#include "netdriver_none.h"

// コンストラクタ
NetDriverNone::NetDriverNone(int loglevel_)
	: inherited("None", NULL, loglevel_)
{
}

// デストラクタ
NetDriverNone::~NetDriverNone()
{
}

// ドライバ初期化 & オープン
bool
NetDriverNone::InitDriver()
{
	putmsg(1, "created");
	return true;
}

// モニタ (ドライバ依存情報のみ)
void
NetDriverNone::MonitorUpdateMD(TextScreen& screen)
{
}

// パケットを送信する
bool
NetDriverNone::SendPacket(const std::vector<uint8>& data)
{
	return true;
}

// パケットを受信する
ssize_t
NetDriverNone::RecvPacket()
{
	// 受信スレッド自体を起動しないので絶対呼び出されない
	PANIC("never call");
}
