//
// nono
// Copyright (C) 2020 nono project
// Licensed under nono-license.txt
//

#pragma once

#include "netdriver.h"

class NetDriverTap : public NetDriver
{
	using inherited = NetDriver;
 public:
	// コンストラクタ
	NetDriverTap(EthernetDevice *parent_, int loglevel_,
		const std::string& devpath_);
	// デストラクタ
	~NetDriverTap() override;

	bool InitDriver() override;
	bool SendPacket(const std::vector<uint8>& data) override;

 protected:
	ssize_t RecvPacket() override;
	void MonitorUpdateMD(TextScreen&) override;

 private:
#if defined(__linux__)
	bool OpenLinux();
#endif
	bool OpenDirect();
	bool OpenNumbered();
	bool OpenCloning();

	void CloseFd();
	void Close();

	// デバイスファイルパス
	std::string devpath {};
};
