//
// nono
// Copyright (C) 2020 nono project
// Licensed under nono-license.txt
//

#pragma once

#include "device.h"

class OPMDevice : public IODevice
{
	using inherited = IODevice;
 private:
	static const int baseaddr = 0xe90000;

 public:
	OPMDevice();
	virtual ~OPMDevice() override;

 protected:
	// BusIO インタフェース
	static const uint32 NPORT = 2;
	uint64 Read(uint32 offset);
	uint64 Write(uint32 offset, uint32 data);
	uint64 Peek(uint32 offset);
};

extern std::unique_ptr<OPMDevice> gOPM;
