//
// nono
// Copyright (C) 2020 nono project
// Licensed under nono-license.txt
//

#pragma once

#include "device.h"

class PartialRAMDevice : public IODevice
{
	using inherited = IODevice;
 public:
	PartialRAMDevice();
	virtual ~PartialRAMDevice() override;

	bool Init() override;

	uint64 Read8(uint32 addr) override;
	uint64 Read16(uint32 addr) override;
	uint64 Read32(uint32 addr) override;
	uint64 Write8(uint32 addr, uint32 data) override;
	uint64 Write16(uint32 addr, uint32 data) override;
	uint64 Write32(uint32 addr, uint32 data) override;
	uint64 Peek8(uint32 addr) override;

 private:
	inline IODevice *SearchDevice(uint32 addr) const;

	uint32 ram_size {};

	IODevice *ramdev {};
	IODevice *nopdev {};
};

extern std::unique_ptr<PartialRAMDevice> gPartialRAM;
