//
// nono
// Copyright (C) 2020 nono project
// Licensed under nono-license.txt
//

#pragma once

#include "rom.h"

class IPLROM1Device;

class IPLROM0Device : public IODevice
{
	using inherited = IODevice;
 public:
	IPLROM0Device();
	virtual ~IPLROM0Device() override;

	bool Init() override;
	void ResetHard() override;

	uint64 Read8(uint32 addr) override;
	uint64 Read16(uint32 addr) override;
	uint64 Read32(uint32 addr) override;
	uint64 Peek8(uint32 addr) override;

 private:
	uint32 ReadDecoder(uint32 addr);

	IPLROM1Device *iplrom1 {};
};

class IPLROM1Device : public ROMDevice
{
	using inherited = ROMDevice;
 public:
	IPLROM1Device();
	virtual ~IPLROM1Device() override;

	bool Init() override;
};

class IPLROM2Device : public ROMDevice
{
	using inherited = ROMDevice;
 public:
	IPLROM2Device();
	virtual ~IPLROM2Device() override;

	bool Init() override;
};

class CGROMDevice : public ROMDevice
{
	using inherited = ROMDevice;
 public:
	CGROMDevice();
	virtual ~CGROMDevice() override;

	bool Init() override;
};

extern std::unique_ptr<CGROMDevice> gCGROM;
extern std::unique_ptr<IPLROM0Device> gIPLROM0;
extern std::unique_ptr<IPLROM1Device> gIPLROM1;
extern std::unique_ptr<IPLROM2Device> gIPLROM2;
