//
// nono
// Copyright (C) 2020 nono project
// Licensed under nono-license.txt
//

#pragma once

#include "device.h"
#include "upd7201.h"

class SIODevice : public uPD7201Device
{
	using inherited = uPD7201Device;
 public:
	SIODevice();
	virtual ~SIODevice() override;

	// BusIO インタフェース
	// (内蔵 ROM からのアクセス用に特別に public にしてある)
	uint64 Read(uint32 offset);
	uint64 Write(uint32 offset, uint32 data);

 protected:
	// BusIO インタフェース
	static const uint32 NPORT = 4;
	uint64 Peek(uint32 offset);

 private:
	void Interrupt() override;
};

extern std::unique_ptr<SIODevice> gSIO;
