//
// nono
// Copyright (C) 2020 nono project
// Licensed under nono-license.txt
//

//
// LUNA LCD パネル
//

#pragma once

#include "wxnono.h"
#include "wxbitmapbuf.h"
#include "wxsubwindow.h"

// LCD パネル
class WXLCDPanel : public wxPanel
{
	using inherited = wxPanel;
 public:
	WXLCDPanel(wxWindow *parent);
	virtual ~WXLCDPanel() override;

 private:
	void OnLCDChanged(wxCommandEvent& event);
	void OnPaint(wxPaintEvent& event);
	void Draw(wxDC&);
	void DrawChar(wxDC&, int x, int y, uint8 ch);

	const uint8 *ddram {};

	WXBitmapBuf bitmap {};

	wxDECLARE_EVENT_TABLE();
};

// LCD ウィンドウ
class WXLCDWindow : public WXSubWindow
{
	using inherited = WXSubWindow;
 public:
	WXLCDWindow(wxWindow *parent);
	virtual ~WXLCDWindow() override;

 private:
	WXLCDPanel *panel {};
};

// LCD キャラクタパネル
class WXLCDCharPanel : public WXPaddingPanel
{
	using inherited = WXPaddingPanel;
 public:
	WXLCDCharPanel(wxWindow *parent);
	virtual ~WXLCDCharPanel() override;

 private:
	void OnPaint(wxPaintEvent& event);
	void Draw(wxDC&);

	WXBitmapBuf bitmap {};

	wxDECLARE_EVENT_TABLE();
};

// LCD キャラクタウィンドウ
class WXLCDMonitor : public WXSubWindow
{
	using inherited = WXSubWindow;
 public:
	WXLCDMonitor(wxWindow *parent);
	virtual ~WXLCDMonitor() override;

 private:
	WXTextScreen *monpanel {};
	WXLCDCharPanel *chrpanel {};
};
